Debian Bug report logs - #508406
inconsistent flags for libmysqld.a on different arches, no README.Debian

version graph

Package: libmysqlclient-dev; Maintainer for libmysqlclient-dev is Debian MySQL Maintainers <pkg-mysql-maint@lists.alioth.debian.org>; Source for libmysqlclient-dev is src:mysql-5.5.

Reported by: Modestas Vainius <modestas@vainius.eu>

Date: Wed, 10 Dec 2008 23:21:01 UTC

Severity: serious

Tags: patch

Found in version mysql-dfsg-5.1/5.1.30-2

Fixed in versions mysql-dfsg-5.1/5.1.36-1, mysql-dfsg-5.1/5.1.36-2

Done: Christian Hammers <ch@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debian MySQL Maintainers <pkg-mysql-maint@lists.alioth.debian.org>:
Bug#508406; Package libmysqlclient-dev. (Wed, 10 Dec 2008 23:21:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Modestas Vainius <modestas@vainius.eu>:
New Bug report received and forwarded. Copy sent to Debian MySQL Maintainers <pkg-mysql-maint@lists.alioth.debian.org>. (Wed, 10 Dec 2008 23:21:23 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Modestas Vainius <modestas@vainius.eu>
To: submit@bugs.debian.org
Subject: inconsistent flags for libmysqld.a on different arches, no README.Debian
Date: Thu, 11 Dec 2008 01:16:03 +0200
[Message part 1 (text/plain, inline)]
Package: libmysqlclient-dev
Version: 5.1.30-2
Tags: patch
Severity: serious
Justification: Violation of MUST in Debian Policy section 10.2

Hello,

This bug is related to #457915.

Currently Debian Policy section 10.2 states:

"As to the static libraries, the common case is not to have relocatable code, 
since there is no benefit, unless in specific cases; therefore the static 
version must not be compiled with the -fPIC flag. Any exception to this rule 
should be discussed on the mailing list debian-devel@lists.debian.org, and the 
reasons for compiling with the -fPIC flag must be recorded in the file 
README.Debian"

libmysqld.a is a static library and it is built with -fPIC only on amd64, but 
that is not described in README.Debian. Also please do not treat a single arch 
specially since that makes absolutely no sense. You either build with -fPIC on 
all arches or none or build both PIC and nonPIC versions on all arches (which 
I'm suggesting).

Therefore this bug is also a request to provide both -fPIC and non-fPIC 
versions of libmysqld.a. I have even written a patch for this (debdiff 
attached). I need libmysqld to be linked into dynamic library [1][2], but I 
can't use it until it is built without -fPIC on other arches.

The changes make mysql build twice without and with -fPIC respectively in 
separate build directories (the 2nd time only libmysqld and its dependencies 
are built). Then both libmysqld.a (nonPIC version) and libmysqld_pic.a (PIC 
version) are installed to libmysqlclient-dev. As a side effect of using out-
of-source-tree builds, hack in clean target is no longer needed. Patch 02  
fixes FTBFS of libmysqld examples due to undefined symbol.

The only remaining part for you is to create a README.Debian. Justification is 
of -fPIC version is simple: libmysqld_pic.a is needed to be able to include it 
into shared libraries, which is a perfectly valid use case for libmysqld. 
Since you still provide nonPIC libmysqld.a, Debian Policy is not violated.

P.S. libmysqld_pic.a and libmysqld.a are around 16MB each and they increase 
package size by 4MBs each. So it makes sense to split them both into their own 
package (libmysqld).


#457915: http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=457915
1. http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=501495
2. http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=508399

-- 
Modestas Vainius <modestas@vainius.eu>

[libmysqld_nonpic_and_pic.diff (text/x-patch, attachment)]
[signature.asc (application/pgp-signature, inline)]

Blocking bugs of 509000 added: 508406 Request was from Modestas Vainius <modestas@vainius.eu> to control@bugs.debian.org. (Wed, 17 Dec 2008 10:54:13 GMT) Full text and rfc822 format available.

Tags added: pending Request was from Norbert Tretkowski <nobse@alioth.debian.org> to control@bugs.debian.org. (Sun, 22 Feb 2009 11:24:02 GMT) Full text and rfc822 format available.

Tags removed: pending Request was from Norbert Tretkowski <nobse@debian.org> to control@bugs.debian.org. (Sun, 22 Feb 2009 12:57:06 GMT) Full text and rfc822 format available.

Tags added: pending Request was from Christian Hammers <ch@alioth.debian.org> to control@bugs.debian.org. (Sun, 05 Jul 2009 22:42:04 GMT) Full text and rfc822 format available.

Reply sent to Christian Hammers <ch@debian.org>:
You have taken responsibility. (Sat, 18 Jul 2009 08:00:14 GMT) Full text and rfc822 format available.

Notification sent to Modestas Vainius <modestas@vainius.eu>:
Bug acknowledged by developer. (Sat, 18 Jul 2009 08:00:14 GMT) Full text and rfc822 format available.

Message #18 received at 508406-close@bugs.debian.org (full text, mbox):

From: Christian Hammers <ch@debian.org>
To: 508406-close@bugs.debian.org
Subject: Bug#508406: fixed in mysql-dfsg-5.1 5.1.36-1
Date: Sat, 18 Jul 2009 07:47:15 +0000
Source: mysql-dfsg-5.1
Source-Version: 5.1.36-1

We believe that the bug you reported is fixed in the latest version of
mysql-dfsg-5.1, which is due to be installed in the Debian FTP archive:

libmysqlclient-dev_5.1.36-1_amd64.deb
  to pool/main/m/mysql-dfsg-5.1/libmysqlclient-dev_5.1.36-1_amd64.deb
libmysqlclient15-dev_5.1.36-1_all.deb
  to pool/main/m/mysql-dfsg-5.1/libmysqlclient15-dev_5.1.36-1_all.deb
libmysqlclient16_5.1.36-1_amd64.deb
  to pool/main/m/mysql-dfsg-5.1/libmysqlclient16_5.1.36-1_amd64.deb
mysql-client-5.1_5.1.36-1_amd64.deb
  to pool/main/m/mysql-dfsg-5.1/mysql-client-5.1_5.1.36-1_amd64.deb
mysql-client_5.1.36-1_all.deb
  to pool/main/m/mysql-dfsg-5.1/mysql-client_5.1.36-1_all.deb
mysql-common_5.1.36-1_all.deb
  to pool/main/m/mysql-dfsg-5.1/mysql-common_5.1.36-1_all.deb
mysql-dfsg-5.1_5.1.36-1.diff.gz
  to pool/main/m/mysql-dfsg-5.1/mysql-dfsg-5.1_5.1.36-1.diff.gz
mysql-dfsg-5.1_5.1.36-1.dsc
  to pool/main/m/mysql-dfsg-5.1/mysql-dfsg-5.1_5.1.36-1.dsc
mysql-dfsg-5.1_5.1.36.orig.tar.gz
  to pool/main/m/mysql-dfsg-5.1/mysql-dfsg-5.1_5.1.36.orig.tar.gz
mysql-server-5.1_5.1.36-1_amd64.deb
  to pool/main/m/mysql-dfsg-5.1/mysql-server-5.1_5.1.36-1_amd64.deb
mysql-server_5.1.36-1_all.deb
  to pool/main/m/mysql-dfsg-5.1/mysql-server_5.1.36-1_all.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 508406@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Christian Hammers <ch@debian.org> (supplier of updated mysql-dfsg-5.1 package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Wed, 01 Jul 2009 20:54:58 +0200
Source: mysql-dfsg-5.1
Binary: libmysqlclient16 libmysqlclient15-dev libmysqlclient-dev mysql-common mysql-client-5.1 mysql-server-5.1 mysql-server mysql-client
Architecture: source all amd64
Version: 5.1.36-1
Distribution: experimental
Urgency: low
Maintainer: Debian MySQL Maintainers <pkg-mysql-maint@lists.alioth.debian.org>
Changed-By: Christian Hammers <ch@debian.org>
Description: 
 libmysqlclient-dev - MySQL database development files
 libmysqlclient15-dev - MySQL database development files - empty transitional package
 libmysqlclient16 - MySQL database client library
 mysql-client - MySQL database client (metapackage depending on the latest versio
 mysql-client-5.1 - MySQL database client binaries
 mysql-common - MySQL database common files (e.g. /etc/mysql/my.cnf)
 mysql-server - MySQL database server (metapackage depending on the latest versio
 mysql-server-5.1 - MySQL database server binaries
Closes: 447028 447713 450535 470854 508406 515145 526254 533999 535492 535500
Changes: 
 mysql-dfsg-5.1 (5.1.36-1) experimental; urgency=low
 .
   [TODO]
   * Link libmysqlclient.so to libmysqlclient_r.so to help applications
     like Apache where some modules, like libaprutil, want to use the thread
     safe library and some, like PHP, do not. As the client library just copies
     data between client and server, we do not expect significant performance
     losses. (thanks to Stefan Fritsch). Closes: #450535
 .
     Add the following to libmysqlclient16.links:
     usr/lib/libmysqlclient_r.so.16.0.0 usr/lib/libmysqlclient.so.16.0.0
 .
   * Ex-maintainer upload :)
   * New upstream release.
   * SECURITY: Upstream fix for "mysql client does not escape strings in
     --html mode." (CVE-2008-4456) Closes: #526254
   * Upstream fixes REPEAT() function. Closes: #447028
   * Upstream fixes problems when mixing ORDER and GROUP BY. Closes: #470854
   * There were many innodb fixes in the last two years, probably
     also for this unreproducible crash. CLoses: #447713
   * Removed amd64 specific -fPIC compiler option that was introduced
     especially for building the NDB cluster module which is no longer
     part of this package (thanks to Modestas Vainius). Closes: #508406
   * Put /etc/mysql/conf.d to mysql-server-5.1.dirs (thanks to Alexander
     Gerasiov). Closes: #515145
   * Fixed mysql-test suite by adding 50_mysql-test__db_test.dpatch.
     It now passes 100% of the tests again. Also Closes: #533999
   * Preinst now prevents Installation if NDB configuration is detected.
   * Applied Ubuntu patch that fixes privilege bootstrapping in postinst
     (thanks to Mathias Gug). Closes: #535492
   * Applied Ubuntu patch that sets the debconf prio for the root password
     question to high and prevents it from being asked on 5.0 -> 5.1 upgrades
     (thanks to Mathias Gug). Closes: #535500
   * Removed the check for ISAM tables as the only supported upgrade path is
     from lenny's MySQL-5.0.
   * Added /etc/mysql/conf.d/mysqld_safe_syslog.cnf which enables mysqld_safe
     to pipe all mysqld output into the syslog. The reason for not letting dpkg
     handle it via a normal config file change was that my.cnf is usually
     heavily tuned by the admin so the setting would go lost too easily.
   * Updated mysqlreport to version 3.5 (including two minor patches by me).
Checksums-Sha1: 
 9318a87ccf4f044052d15d7c3b837e1d19c11b8a 1652 mysql-dfsg-5.1_5.1.36-1.dsc
 c5efbf1821742d2e7b1c02511d266de117c19b0a 18263034 mysql-dfsg-5.1_5.1.36.orig.tar.gz
 3d864cab767100ccd58dba90440d5742c8fc8694 283528 mysql-dfsg-5.1_5.1.36-1.diff.gz
 77f3bb147cb5156a6f48a800ec8fbd3e9005623d 54884 libmysqlclient15-dev_5.1.36-1_all.deb
 e685fc0564a49e5374c48e4d823d1f9ce79e6cc8 60446 mysql-common_5.1.36-1_all.deb
 a9b8c080debd736712939631b5c9eedcec268cbf 55068 mysql-server_5.1.36-1_all.deb
 11042c2b51d709bc8279d57770693c2d0feedcf7 54936 mysql-client_5.1.36-1_all.deb
 b4196190051238f621e6c865b65138ae556bfef7 1953306 libmysqlclient16_5.1.36-1_amd64.deb
 67b4bbe30243644a4c30de69f860d81523d14a97 6678002 libmysqlclient-dev_5.1.36-1_amd64.deb
 ba502cb869281064a7862acba13c3bcb03f0394c 9115414 mysql-client-5.1_5.1.36-1_amd64.deb
 46d7a1be6707fb5fe7bbedda2657eb24ded3668c 10732690 mysql-server-5.1_5.1.36-1_amd64.deb
Checksums-Sha256: 
 b74eea53f321837c1054b70734b3bde6ef235db1737cdebfb5d3e9d5ac05ef9d 1652 mysql-dfsg-5.1_5.1.36-1.dsc
 a2a70518069d93f6bb3d1561db4d2e622db9d9c08acd99b0f9509d3eedb9b47b 18263034 mysql-dfsg-5.1_5.1.36.orig.tar.gz
 b0c54fdca2b544fcc9f5336a67a747df1319a5fb41838dffa6556c8510d2143e 283528 mysql-dfsg-5.1_5.1.36-1.diff.gz
 8321c34a66ce39a75e1fab6596d9d07bd0a5fd01806e2e8b2b4f21ee1f3a923e 54884 libmysqlclient15-dev_5.1.36-1_all.deb
 0d9ca1595df1801286e9df03ab38763182fbf2444a3f42bb0464c6bf129b921a 60446 mysql-common_5.1.36-1_all.deb
 212ea536178c8dc8a0ffa72fa0d0338ff1122126b2e8592520fc44e655c0bc2b 55068 mysql-server_5.1.36-1_all.deb
 01c47078f14b518b571cc673673e9221b2f8e601702f82ba54ff95632f8613fb 54936 mysql-client_5.1.36-1_all.deb
 e74cfbc7c6020da35324452817bf4f2cbad9a22723e65821e9d797d0c0f15f44 1953306 libmysqlclient16_5.1.36-1_amd64.deb
 65b27dd8eaf10446273d393249ee4ccf5367a869eef1ea0ec72cf191b4766bf2 6678002 libmysqlclient-dev_5.1.36-1_amd64.deb
 5af25a00a5fa01dd5c4ba5339026477b683a525c1665aa8cba419a88d753146d 9115414 mysql-client-5.1_5.1.36-1_amd64.deb
 e743bbba3eac77237714718f50ff933acc1ddba6436f14bc938d41acba3f7510 10732690 mysql-server-5.1_5.1.36-1_amd64.deb
Files: 
 2e91cb7645287cc50125122d712fba74 1652 misc optional mysql-dfsg-5.1_5.1.36-1.dsc
 02a83e864464b4ce78bda453061e6b32 18263034 misc optional mysql-dfsg-5.1_5.1.36.orig.tar.gz
 9e59959fd0e59d08024475a69e79f706 283528 misc optional mysql-dfsg-5.1_5.1.36-1.diff.gz
 73b60780efce81d54ae8c6a4fc997a86 54884 libdevel optional libmysqlclient15-dev_5.1.36-1_all.deb
 fca1cbc3e7ea7953cb881b356b8c5103 60446 database optional mysql-common_5.1.36-1_all.deb
 07c696ba56b2dd5911c85043644d9030 55068 database optional mysql-server_5.1.36-1_all.deb
 464af2e560a25bc4280d608549afcf85 54936 database optional mysql-client_5.1.36-1_all.deb
 958b6344244bc80c1e07269d1f5e62fe 1953306 libs optional libmysqlclient16_5.1.36-1_amd64.deb
 e579a7e9754714ff0388e44d02755238 6678002 libdevel optional libmysqlclient-dev_5.1.36-1_amd64.deb
 7bc700db8e7afa4e1602c4ed534e9ae7 9115414 misc optional mysql-client-5.1_5.1.36-1_amd64.deb
 4fa4b94879e00166d170d964d1d6ebf4 10732690 misc optional mysql-server-5.1_5.1.36-1_amd64.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.9 (GNU/Linux)

iEYEARECAAYFAkpheVcACgkQr/RnCw96jQF5wwCeN//Hq/Q1V4PENEWX8gCquaaj
A5YAoJY0WU3eepppyD8kp5GsV/Vt/zf9
=oByX
-----END PGP SIGNATURE-----





Information forwarded to debian-bugs-dist@lists.debian.org, Debian MySQL Maintainers <pkg-mysql-maint@lists.alioth.debian.org>:
Bug#508406; Package libmysqlclient-dev. (Sat, 18 Jul 2009 18:27:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Modestas Vainius <modestas@vainius.eu>:
Extra info received and forwarded to list. Copy sent to Debian MySQL Maintainers <pkg-mysql-maint@lists.alioth.debian.org>. (Sat, 18 Jul 2009 18:27:06 GMT) Full text and rfc822 format available.

Message #23 received at 508406@bugs.debian.org (full text, mbox):

From: Modestas Vainius <modestas@vainius.eu>
To: Christian Hammers <ch@debian.org>
Cc: 508406@bugs.debian.org
Subject: Re: Bug#508406: fixed in mysql-dfsg-5.1 5.1.36-1
Date: Sat, 18 Jul 2009 21:25:02 +0300
[Message part 1 (text/plain, inline)]
Hello,

On šeštadienis 18 Liepa 2009 10:47:15 Christian Hammers wrote:
>    * Removed amd64 specific -fPIC compiler option that was introduced
>      especially for building the NDB cluster module which is no longer
>      part of this package (thanks to Modestas Vainius). Closes: #508406

It is really unfortunate you chose the easiest way to solve this bug (removing 
-fPIC version rather than adding both). This means libmysqld still cannot be 
linked to shared libraries. Fortunately, I have found a workaround for my 
package but it's only a matter of time before somebody else needs -fPIC 
version of libmysqld. Most other distros have them.

-- 
Modestas Vainius <modestas@vainius.eu>
[signature.asc (application/pgp-signature, inline)]

Tags added: pending Request was from Christian Hammers <ch@alioth.debian.org> to control@bugs.debian.org. (Mon, 20 Jul 2009 17:21:04 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian MySQL Maintainers <pkg-mysql-maint@lists.alioth.debian.org>:
Bug#508406; Package libmysqlclient-dev. (Mon, 20 Jul 2009 17:24:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Christian Hammers <ch@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian MySQL Maintainers <pkg-mysql-maint@lists.alioth.debian.org>. (Mon, 20 Jul 2009 17:24:02 GMT) Full text and rfc822 format available.

Message #30 received at 508406@bugs.debian.org (full text, mbox):

From: Christian Hammers <ch@debian.org>
To: Modestas Vainius <modestas@vainius.eu>
Cc: 508406@bugs.debian.org
Subject: Re: Bug#508406: fixed in mysql-dfsg-5.1 5.1.36-1
Date: Mon, 20 Jul 2009 19:16:53 +0200

On 2009-07-18 Modestas Vainius wrote:
> Hello,
> 
> On šeštadienis 18 Liepa 2009 10:47:15 Christian Hammers wrote:
> >    * Removed amd64 specific -fPIC compiler option that was introduced
> >      especially for building the NDB cluster module which is no longer
> >      part of this package (thanks to Modestas Vainius). Closes: #508406
> 
> It is really unfortunate you chose the easiest way to solve this bug
> (removing -fPIC version rather than adding both). This means libmysqld
> still cannot be linked to shared libraries. Fortunately, I have found a
> workaround for my package but it's only a matter of time before somebody
> else needs -fPIC version of libmysqld. Most other distros have them.

I guess you're initial mail was just too long. I didn't read it completely :)
As the idea of out-of-source-building was very good, as well, I've applied
the patch.

bye,

-christian-




Information forwarded to debian-bugs-dist@lists.debian.org, Debian MySQL Maintainers <pkg-mysql-maint@lists.alioth.debian.org>:
Bug#508406; Package libmysqlclient-dev. (Mon, 20 Jul 2009 21:12:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Christian Hammers <ch@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian MySQL Maintainers <pkg-mysql-maint@lists.alioth.debian.org>. (Mon, 20 Jul 2009 21:12:03 GMT) Full text and rfc822 format available.

Message #35 received at 508406@bugs.debian.org (full text, mbox):

From: Christian Hammers <ch@debian.org>
To: debian-devel@lists.debian.org
Cc: 508406@bugs.debian.org
Subject: Intend to create an -fPIC library package...
Date: Mon, 20 Jul 2009 23:10:11 +0200
Hello

In the Cc'ed bug report we were asked to created a libmysqld-pic package that
only contains libmysqld_pic.a which should be compiled with -fPIC.
As I'm no library expert I gladly follow the recommendation of Policy §10.2
and ask for comments :) The reason for creating this package was that
libmysqld.a (the embeddable MySQL server) should be included in other shared
libraries, like one from Modestas' Amarok package.

bye,

-christian-







Tags added: pending Request was from Christian Hammers <ch@alioth.debian.org> to control@bugs.debian.org. (Mon, 20 Jul 2009 21:27:03 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian MySQL Maintainers <pkg-mysql-maint@lists.alioth.debian.org>:
Bug#508406; Package libmysqlclient-dev. (Mon, 20 Jul 2009 22:27:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Roger Leigh <rleigh@codelibre.net>:
Extra info received and forwarded to list. Copy sent to Debian MySQL Maintainers <pkg-mysql-maint@lists.alioth.debian.org>. (Mon, 20 Jul 2009 22:27:02 GMT) Full text and rfc822 format available.

Message #42 received at 508406@bugs.debian.org (full text, mbox):

From: Roger Leigh <rleigh@codelibre.net>
To: Christian Hammers <ch@debian.org>
Cc: debian-devel@lists.debian.org, 508406@bugs.debian.org
Subject: Re: Intend to create an -fPIC library package...
Date: Mon, 20 Jul 2009 23:18:23 +0100
[Message part 1 (text/plain, inline)]
On Mon, Jul 20, 2009 at 11:10:11PM +0200, Christian Hammers wrote:
> Hello
> 
> In the Cc'ed bug report we were asked to created a libmysqld-pic package that
> only contains libmysqld_pic.a which should be compiled with -fPIC.
> As I'm no library expert I gladly follow the recommendation of Policy §10.2
> and ask for comments :) The reason for creating this package was that
> libmysqld.a (the embeddable MySQL server) should be included in other shared
> libraries, like one from Modestas' Amarok package.

If other libraries are including this library, then why is libmysqld
not being provided as a properly-versioned shared object?

I am not convinced that compiling with -fPIC is appropriate here--it's
working around the fact that mysql isn't providing a properly
reusable shared library.  Linking an -fPIC static library (a) with a
shared library (b) will make the contents of (a) part of the exported
interface of (b) because it will by default be added to the dynamic
symbol table unless you take special action with linker scripts.

There are obvious issues with security updates if people are linking
against libmysqld.a, since all libraries linking against it will need
rebuilding if there's a security update.  If it's shared, that won't
normally be required.


Regards,
Roger

-- 
  .''`.  Roger Leigh
 : :' :  Debian GNU/Linux             http://people.debian.org/~rleigh/
 `. `'   Printing on GNU/Linux?       http://gutenprint.sourceforge.net/
   `-    GPG Public Key: 0x25BFB848   Please GPG sign your mail.
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian MySQL Maintainers <pkg-mysql-maint@lists.alioth.debian.org>:
Bug#508406; Package libmysqlclient-dev. (Mon, 20 Jul 2009 22:45:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Christian Hammers <ch@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian MySQL Maintainers <pkg-mysql-maint@lists.alioth.debian.org>. (Mon, 20 Jul 2009 22:45:02 GMT) Full text and rfc822 format available.

Message #47 received at 508406@bugs.debian.org (full text, mbox):

From: Christian Hammers <ch@debian.org>
To: Roger Leigh <rleigh@codelibre.net>
Cc: debian-devel@lists.debian.org, 508406@bugs.debian.org
Subject: Re: Intend to create an -fPIC library package...
Date: Tue, 21 Jul 2009 00:40:17 +0200
Am Mon, 20 Jul 2009 23:18:23 +0100
schrieb Roger Leigh <rleigh@codelibre.net>:

> On Mon, Jul 20, 2009 at 11:10:11PM +0200, Christian Hammers wrote:
> > Hello
> > 
> > In the Cc'ed bug report we were asked to created a libmysqld-pic
> > package that only contains libmysqld_pic.a which should be compiled
> > with -fPIC. As I'm no library expert I gladly follow the
> > recommendation of Policy §10.2 and ask for comments :) The reason
> > for creating this package was that libmysqld.a (the embeddable
> > MySQL server) should be included in other shared libraries, like
> > one from Modestas' Amarok package.
> 
> If other libraries are including this library, then why is libmysqld
> not being provided as a properly-versioned shared object?

Upstream, in this case Monty himself, seems to explicitly want it to be
a static library for performance reasons as I read from the discussion
in: http://lists.mysql.com/internals/35950

> I am not convinced that compiling with -fPIC is appropriate here--it's
> working around the fact that mysql isn't providing a properly
> reusable shared library.  Linking an -fPIC static library (a) with a
> shared library (b) will make the contents of (a) part of the exported
> interface of (b) because it will by default be added to the dynamic
> symbol table unless you take special action with linker scripts.
> 
> There are obvious issues with security updates if people are linking
> against libmysqld.a, since all libraries linking against it will need
> rebuilding if there's a security update.  If it's shared, that won't
> normally be required.

At least RedHat and Gentoo already have experimented with building their
own shared libraries from libmysqld.a:
https://bugzilla.redhat.com/show_bug.cgi?id=149829
https://bugs.gentoo.org/attachment.cgi?id=186606

So I try to get this working on Debian, too, and create a libmysqld0
package with a shared library instead. Speaking of it, which soname
version should I give it? 0.0.0? Or something like 0.5137.0 to somehow
encode a version as I cannot promise that *I* know when
they make API changes? .so.5.1.37 seems not to be a good idea in case
MySQL somewhen starts to ship a libmysqld.so.5 themselves.

bye,

-christian-




Information forwarded to debian-bugs-dist@lists.debian.org, Debian MySQL Maintainers <pkg-mysql-maint@lists.alioth.debian.org>:
Bug#508406; Package libmysqlclient-dev. (Tue, 21 Jul 2009 13:57:08 GMT) Full text and rfc822 format available.

Acknowledgement sent to Wouter Verhelst <wouter@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian MySQL Maintainers <pkg-mysql-maint@lists.alioth.debian.org>. (Tue, 21 Jul 2009 13:57:08 GMT) Full text and rfc822 format available.

Message #52 received at 508406@bugs.debian.org (full text, mbox):

From: Wouter Verhelst <wouter@debian.org>
To: Christian Hammers <ch@debian.org>
Cc: Roger Leigh <rleigh@codelibre.net>, debian-devel@lists.debian.org, 508406@bugs.debian.org
Subject: Re: Intend to create an -fPIC library package...
Date: Tue, 21 Jul 2009 15:55:24 +0200
[Message part 1 (text/plain, inline)]
On Tue, Jul 21, 2009 at 12:40:17AM +0200, Christian Hammers wrote:
> Am Mon, 20 Jul 2009 23:18:23 +0100
> schrieb Roger Leigh <rleigh@codelibre.net>:
> > If other libraries are including this library, then why is libmysqld
> > not being provided as a properly-versioned shared object?
> 
> Upstream, in this case Monty himself, seems to explicitly want it to be
> a static library for performance reasons as I read from the discussion
> in: http://lists.mysql.com/internals/35950

In that case, and if we do indeed want to support this static library
interface, indirect users of libmysqld.a should link to it when they
compile their software. Shared libraries can in fact use symbols from
the 'main' program if they're compiled in like that -- except that, of
course, these shared libraries then depend on the assumption that the
static library does not change its ABI, and they have no way at all to
ensure that.

Adding a -fPIC static library obviously does not fix that problem; it
only makes the ABI management of those libraries that link in the -fPIC
static library infinitely more complex. Additionally, you introduce a
serious problem that may only be fixed by requiring that any library
which includes this -fPIC static library needs to use either symbol
versions or linker tricks to avoid multiple versions of the same symbol
from stumping on eachother's toes.

Whether we should recommend using static libraries is another matter
entirely; indeed performance does go down a teeny weeny bit when using
shared libraries, but the difference shouldn't be *that* large; if it
is, that probably means they're using a twisty maze of function calls,
all alike, that they probably shouldn't be doing. In my opinion, the
advantages gained by not doing shared libraries do not, by far, outweigh
the serious problems it introduces.

All this really sounds like a cop-out in that mysql upstream doesn't
want to deal with *real* performance optimizations. Not that I'd
expected something much different from MySQL. But I digress.

> > I am not convinced that compiling with -fPIC is appropriate here--it's
> > working around the fact that mysql isn't providing a properly
> > reusable shared library.  Linking an -fPIC static library (a) with a
> > shared library (b) will make the contents of (a) part of the exported
> > interface of (b) because it will by default be added to the dynamic
> > symbol table unless you take special action with linker scripts.
> > 
> > There are obvious issues with security updates if people are linking
> > against libmysqld.a, since all libraries linking against it will need
> > rebuilding if there's a security update.  If it's shared, that won't
> > normally be required.
> 
> At least RedHat and Gentoo already have experimented with building their
> own shared libraries from libmysqld.a:
> https://bugzilla.redhat.com/show_bug.cgi?id=149829
> https://bugs.gentoo.org/attachment.cgi?id=186606
> 
> So I try to get this working on Debian, too, and create a libmysqld0
> package with a shared library instead. Speaking of it, which soname
> version should I give it? 0.0.0? Or something like 0.5137.0 to somehow
> encode a version as I cannot promise that *I* know when
> they make API changes? .so.5.1.37 seems not to be a good idea in case
> MySQL somewhen starts to ship a libmysqld.so.5 themselves.

Don't just blindly use 'version of the server package' unless you really
really know what you're doing.

A SONAME should be bumped (i.e., the number after the .so. bit of the
filename and before the next dot increased) when the ABI changes
incompatibly. This may be when upstream changes the API incompatibly
(probably indeed only happens on an upstream major update), but there
are other cases where this might be the case (say, they add a variable
to a struct in a way so that the offsets change, or rely on users to use
malloc(sizeof(struct)) to allocate a new one, or a number of other
things) that might change at a minor (i.e., 5.1 -> 5.2) update. If that
happens, and you rely on the major upstream version number (5 in the
example) to change, then you've just created a shared object which
claims it is compatible with previous versions of itself but isn't, and
things will go kaboom all over the place.

Basically, I guess the only proper answer to your question is either
"audit upstream's ABI and bump the SONAME when required" or "slap
upstream in the face and demand they provide a proper shared library".
Except without the rudeness.

If you don't want to do either, then the only safe option you have is to
use libtool's -release option (or an equivalent of that which does not
use libtool). This, however, will mean that every time you do an
upstream update, even a minor one, you have a library transition on your
hands.

-- 
The biometric identification system at the gates of the CIA headquarters
works because there's a guard with a large gun making sure no one is
trying to fool the system.
  http://www.schneier.com/blog/archives/2009/01/biometrics.html
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian MySQL Maintainers <pkg-mysql-maint@lists.alioth.debian.org>:
Bug#508406; Package libmysqlclient-dev. (Tue, 21 Jul 2009 14:24:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Peter Samuelson <peter@p12n.org>:
Extra info received and forwarded to list. Copy sent to Debian MySQL Maintainers <pkg-mysql-maint@lists.alioth.debian.org>. (Tue, 21 Jul 2009 14:24:02 GMT) Full text and rfc822 format available.

Message #57 received at 508406@bugs.debian.org (full text, mbox):

From: Peter Samuelson <peter@p12n.org>
To: debian-devel@lists.debian.org, 508406@bugs.debian.org
Subject: Re: Intend to create an -fPIC library package...
Date: Tue, 21 Jul 2009 09:17:28 -0500
[Wouter Verhelst]
> Whether we should recommend using static libraries is another matter
> entirely; indeed performance does go down a teeny weeny bit when using
> shared libraries, but the difference shouldn't be *that* large; if it
> is, that probably means they're using a twisty maze of function calls,
> all alike, that they probably shouldn't be doing.

As I understand it, the performance drawbacks of a shared library are:

1) The PIC code and its use of a GOT.  Given that we're talking about a
   PIC static library, this is not relevant.

2) Runtime linking.  This is overhead at application startup time.
   Something that embeds an SQL engine should not, I think, start up too
   frequently.  Am I wrong?

So what is the real performance advantage of this -fPIC static library?
To me it looks like a different, less desirable, way to implement the
'prelink' optimization.
-- 
Peter Samuelson | org-tld!p12n!peter | http://p12n.org/




Information forwarded to debian-bugs-dist@lists.debian.org, Debian MySQL Maintainers <pkg-mysql-maint@lists.alioth.debian.org>:
Bug#508406; Package libmysqlclient-dev. (Tue, 21 Jul 2009 15:00:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Wouter Verhelst <wouter@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian MySQL Maintainers <pkg-mysql-maint@lists.alioth.debian.org>. (Tue, 21 Jul 2009 15:00:06 GMT) Full text and rfc822 format available.

Message #62 received at 508406@bugs.debian.org (full text, mbox):

From: Wouter Verhelst <wouter@debian.org>
To: Peter Samuelson <peter@p12n.org>
Cc: debian-devel@lists.debian.org, 508406@bugs.debian.org
Subject: Re: Intend to create an -fPIC library package...
Date: Tue, 21 Jul 2009 16:52:52 +0200
[Message part 1 (text/plain, inline)]
On Tue, Jul 21, 2009 at 09:17:28AM -0500, Peter Samuelson wrote:
> 
> [Wouter Verhelst]
> > Whether we should recommend using static libraries is another matter
> > entirely; indeed performance does go down a teeny weeny bit when using
> > shared libraries, but the difference shouldn't be *that* large; if it
> > is, that probably means they're using a twisty maze of function calls,
> > all alike, that they probably shouldn't be doing.
> 
> As I understand it, the performance drawbacks of a shared library are:
> 
> 1) The PIC code and its use of a GOT.  Given that we're talking about a
>    PIC static library, this is not relevant.

The argument was that a shared library is 'too slow'. Reading the
discussion thread that Christian pointed to, it appears that Monty
doesn't actually know what he's talking about, but read on some random
IBM website that shared libraries are slower. Well, yes they are, but
not by much, and the pain static libraries introduce outweighs that by
much.

Note also that shared libraries are only slower on x86 hardware due to
the fact that they don't natively do PC-relative addressing, which needs
to be emulated; x86_64 has dealt with this, and most other architecture
(including m68k, for those following along at home) properly support it.

> 2) Runtime linking.  This is overhead at application startup time.
>    Something that embeds an SQL engine should not, I think, start up too
>    frequently.  Am I wrong?

Frankly, I'd hope not.

> So what is the real performance advantage of this -fPIC static library?
> To me it looks like a different, less desirable, way to implement the
> 'prelink' optimization.

Looks like it, indeed.

-- 
The biometric identification system at the gates of the CIA headquarters
works because there's a guard with a large gun making sure no one is
trying to fool the system.
  http://www.schneier.com/blog/archives/2009/01/biometrics.html
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian MySQL Maintainers <pkg-mysql-maint@lists.alioth.debian.org>:
Bug#508406; Package libmysqlclient-dev. (Tue, 21 Jul 2009 21:00:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Christian Hammers <ch@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian MySQL Maintainers <pkg-mysql-maint@lists.alioth.debian.org>. (Tue, 21 Jul 2009 21:00:02 GMT) Full text and rfc822 format available.

Message #67 received at 508406@bugs.debian.org (full text, mbox):

From: Christian Hammers <ch@debian.org>
To: Wouter Verhelst <wouter@debian.org>
Cc: Roger Leigh <rleigh@codelibre.net>, debian-devel@lists.debian.org, 508406@bugs.debian.org
Subject: Re: Intend to create an -fPIC library package...
Date: Tue, 21 Jul 2009 22:58:14 +0200
Hello

On 2009-07-21 Wouter Verhelst wrote:
> On Tue, Jul 21, 2009 at 12:40:17AM +0200, Christian Hammers wrote:
> > Am Mon, 20 Jul 2009 23:18:23 +0100
> > schrieb Roger Leigh <rleigh@codelibre.net>:
> > > If other libraries are including this library, then why is libmysqld
> > > not being provided as a properly-versioned shared object?
> > 
> > Upstream, in this case Monty himself, seems to explicitly want it to be
> > a static library for performance reasons as I read from the discussion
> > in: http://lists.mysql.com/internals/35950
> 
> In that case, and if we do indeed want to support this static library
> interface, indirect users of libmysqld.a should link to it when they
> compile their software. Shared libraries can in fact use symbols from
> the 'main' program if they're compiled in like that -- except that, of
> course, these shared libraries then depend on the assumption that the
> static library does not change its ABI, and they have no way at all to
> ensure that.

First, thanks for the long answer, Wouter! 

To wrap it up:
* static libraries are a PITA in case of security problems
* static libraries are a PITA for other projects as they have no versions
* shared libraries with self chosen soname or --release= versions are even 
  PITA as I, as a maintainer, surely won't watch for ABI breakages
* MySQL is a ... :)

As I don't care much and the Amarok team asked to provide a -fPIC version my
plan is to provide both a static and a pic version to them but in different
packages so that in case of a security problem the relevant packages with
build-deps can be identified, after which it's their maintainers problem to 
provide a DSA as well. If the Security-Team or Release Managers clearly 
reject this, I remove the packages again until the Amarok'ers have come to 
agreement with them on what's acceptable for Debian.

bye,

-christian-





Information forwarded to debian-bugs-dist@lists.debian.org, Debian MySQL Maintainers <pkg-mysql-maint@lists.alioth.debian.org>:
Bug#508406; Package libmysqlclient-dev. (Wed, 22 Jul 2009 04:00:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Steve Langasek <vorlon@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian MySQL Maintainers <pkg-mysql-maint@lists.alioth.debian.org>. (Wed, 22 Jul 2009 04:00:02 GMT) Full text and rfc822 format available.

Message #72 received at 508406@bugs.debian.org (full text, mbox):

From: Steve Langasek <vorlon@debian.org>
To: Wouter Verhelst <wouter@debian.org>
Cc: debian-devel@lists.debian.org, 508406@bugs.debian.org
Subject: Re: Intend to create an -fPIC library package...
Date: Tue, 21 Jul 2009 20:58:52 -0700
On Tue, Jul 21, 2009 at 04:52:52PM +0200, Wouter Verhelst wrote:
> > As I understand it, the performance drawbacks of a shared library are:

> > 1) The PIC code and its use of a GOT.  Given that we're talking about a
> >    PIC static library, this is not relevant.

> The argument was that a shared library is 'too slow'. Reading the
> discussion thread that Christian pointed to, it appears that Monty
> doesn't actually know what he's talking about, but read on some random
> IBM website that shared libraries are slower. Well, yes they are, but
> not by much, and the pain static libraries introduce outweighs that by
> much.

> Note also that shared libraries are only slower on x86 hardware due to
> the fact that they don't natively do PC-relative addressing, which needs
> to be emulated; x86_64 has dealt with this, and most other architecture
> (including m68k, for those following along at home) properly support it.

Yes, the *main* reason shared libraries are "too slow" is because they have
to be built with -fPIC, *and -fPIC is slow on i386*.

So building a _pic static library is pointless here, because it avoids all
the benefits of a shared library while bringing in the one drawback of
shared libraries that upstream appears to actually care about.

This should be maintained as a shared library instead.  Static libraries are
bad for security in general, and absolutely awful when they embed something
like a sql server.
 
-- 
Steve Langasek                   Give me a lever long enough and a Free OS
Debian Developer                   to set it on, and I can move the world.
Ubuntu Developer                                    http://www.debian.org/
slangasek@ubuntu.com                                     vorlon@debian.org




Information forwarded to debian-bugs-dist@lists.debian.org, Debian MySQL Maintainers <pkg-mysql-maint@lists.alioth.debian.org>:
Bug#508406; Package libmysqlclient-dev. (Wed, 22 Jul 2009 11:24:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Bernd Zeimetz <bernd@bzed.de>:
Extra info received and forwarded to list. Copy sent to Debian MySQL Maintainers <pkg-mysql-maint@lists.alioth.debian.org>. (Wed, 22 Jul 2009 11:24:02 GMT) Full text and rfc822 format available.

Message #77 received at 508406@bugs.debian.org (full text, mbox):

From: Bernd Zeimetz <bernd@bzed.de>
To: debian-devel@lists.debian.org
Cc: 508406@bugs.debian.org
Subject: Re: Intend to create an -fPIC library package...
Date: Wed, 22 Jul 2009 13:15:23 +0200
Peter Samuelson wrote:

> 2) Runtime linking.  This is overhead at application startup time.
>    Something that embeds an SQL engine should not, I think, start up too
>    frequently.  Am I wrong?

We're talking about amarok here. As a medi aplayer I could imagine it will be
starte several times per day...

-- 
 Bernd Zeimetz                             Debian GNU/Linux Developer
 GPG Fingerprints: 06C8 C9A2 EAAD E37E 5B2C BE93 067A AD04 C93B FF79
                   ECA1 E3F2 8E11 2432 D485 DD95 EB36 171A 6FF9 435F




Information forwarded to debian-bugs-dist@lists.debian.org, Debian MySQL Maintainers <pkg-mysql-maint@lists.alioth.debian.org>:
Bug#508406; Package libmysqlclient-dev. (Wed, 22 Jul 2009 18:03:07 GMT) Full text and rfc822 format available.

Acknowledgement sent to Peter Samuelson <peter@p12n.org>:
Extra info received and forwarded to list. Copy sent to Debian MySQL Maintainers <pkg-mysql-maint@lists.alioth.debian.org>. (Wed, 22 Jul 2009 18:03:07 GMT) Full text and rfc822 format available.

Message #82 received at 508406@bugs.debian.org (full text, mbox):

From: Peter Samuelson <peter@p12n.org>
To: debian-devel@lists.debian.org, 508406@bugs.debian.org
Subject: Re: Intend to create an -fPIC library package...
Date: Wed, 22 Jul 2009 12:58:40 -0500
> > 2) Runtime linking.  This is overhead at application startup time.
> >    Something that embeds an SQL engine should not, I think, start up too
> >    frequently.  Am I wrong?

[Bernd Zeimetz]
> We're talking about amarok here. As a medi aplayer I could imagine it
> will be starte several times per day...

Depends: amarok-common, amarok-engine-xine | amarok-engine-yauap,
    unzip, kdelibs4c2a, libc6, libgcc1, libgl1-mesa-glx | libgl1,
    libglib2.0-0, libgpod3-nogtk | libgpod3, libifp4, libkarma0,
    libmtp7, libmysqlclient15off, libnjb5, libpq5, libqt3-mt,
    libruby1.8, libsdl1.2debian, libsqlite3-0, libstdc++6, libtag1c2a,
    libtunepimp5, libusb-0.1-4, libvisual-0.4-0

...I don't think the 'startup overhead of a shlib' argument holds up.
-- 
Peter Samuelson | org-tld!p12n!peter | http://p12n.org/




Reply sent to Christian Hammers <ch@debian.org>:
You have taken responsibility. (Sat, 25 Jul 2009 11:00:05 GMT) Full text and rfc822 format available.

Notification sent to Modestas Vainius <modestas@vainius.eu>:
Bug acknowledged by developer. (Sat, 25 Jul 2009 11:00:05 GMT) Full text and rfc822 format available.

Message #87 received at 508406-close@bugs.debian.org (full text, mbox):

From: Christian Hammers <ch@debian.org>
To: 508406-close@bugs.debian.org
Subject: Bug#508406: fixed in mysql-dfsg-5.1 5.1.36-2
Date: Sat, 25 Jul 2009 10:14:01 +0000
Source: mysql-dfsg-5.1
Source-Version: 5.1.36-2

We believe that the bug you reported is fixed in the latest version of
mysql-dfsg-5.1, which is due to be installed in the Debian FTP archive:

libmysqlclient-dev_5.1.36-2_amd64.deb
  to pool/main/m/mysql-dfsg-5.1/libmysqlclient-dev_5.1.36-2_amd64.deb
libmysqlclient15-dev_5.1.36-2_all.deb
  to pool/main/m/mysql-dfsg-5.1/libmysqlclient15-dev_5.1.36-2_all.deb
libmysqlclient16_5.1.36-2_amd64.deb
  to pool/main/m/mysql-dfsg-5.1/libmysqlclient16_5.1.36-2_amd64.deb
libmysqld-dev_5.1.36-2_amd64.deb
  to pool/main/m/mysql-dfsg-5.1/libmysqld-dev_5.1.36-2_amd64.deb
libmysqld-pic_5.1.36-2_amd64.deb
  to pool/main/m/mysql-dfsg-5.1/libmysqld-pic_5.1.36-2_amd64.deb
mysql-client-5.1_5.1.36-2_amd64.deb
  to pool/main/m/mysql-dfsg-5.1/mysql-client-5.1_5.1.36-2_amd64.deb
mysql-client_5.1.36-2_all.deb
  to pool/main/m/mysql-dfsg-5.1/mysql-client_5.1.36-2_all.deb
mysql-common_5.1.36-2_all.deb
  to pool/main/m/mysql-dfsg-5.1/mysql-common_5.1.36-2_all.deb
mysql-dfsg-5.1_5.1.36-2.diff.gz
  to pool/main/m/mysql-dfsg-5.1/mysql-dfsg-5.1_5.1.36-2.diff.gz
mysql-dfsg-5.1_5.1.36-2.dsc
  to pool/main/m/mysql-dfsg-5.1/mysql-dfsg-5.1_5.1.36-2.dsc
mysql-server-5.1_5.1.36-2_amd64.deb
  to pool/main/m/mysql-dfsg-5.1/mysql-server-5.1_5.1.36-2_amd64.deb
mysql-server_5.1.36-2_all.deb
  to pool/main/m/mysql-dfsg-5.1/mysql-server_5.1.36-2_all.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 508406@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Christian Hammers <ch@debian.org> (supplier of updated mysql-dfsg-5.1 package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Sun, 19 Jul 2009 18:48:53 +0200
Source: mysql-dfsg-5.1
Binary: libmysqlclient16 libmysqlclient15-dev libmysqld-pic libmysqld-dev libmysqlclient-dev mysql-common mysql-client-5.1 mysql-server-5.1 mysql-server mysql-client
Architecture: source all amd64
Version: 5.1.36-2
Distribution: experimental
Urgency: low
Maintainer: Debian MySQL Maintainers <pkg-mysql-maint@lists.alioth.debian.org>
Changed-By: Christian Hammers <ch@debian.org>
Description: 
 libmysqlclient-dev - MySQL database development files
 libmysqlclient15-dev - MySQL database development files - empty transitional package
 libmysqlclient16 - MySQL database client library
 libmysqld-dev - MySQL embedded database development files
 libmysqld-pic - MySQL database development files
 mysql-client - MySQL database client (metapackage depending on the latest versio
 mysql-client-5.1 - MySQL database client binaries
 mysql-common - MySQL database common files (e.g. /etc/mysql/my.cnf)
 mysql-server - MySQL database server (metapackage depending on the latest versio
 mysql-server-5.1 - MySQL database server binaries
Closes: 508406
Changes: 
 mysql-dfsg-5.1 (5.1.36-2) experimental; urgency=low
 .
   * Build both -fPIC (libmysql_pic.a) and non -fPIC (libmysqld.a) as
     some packages seem to need the -fPIC variant for their own build
     process. Documented in README.Debian. Thanks to Modestas Vainius
     for the patch. Closes: #508406
   * Switch to out-of-source true build mode was a side effect of this change.
   * Added libmysqlclient16.symbols file (thanks to Raphael Hertzog).
   * Raised debian/compat from 4 to 7.
   * Updated innotop to 1.7.1.
   * Minor cleanups that lintian suggested.
Checksums-Sha1: 
 ec4239aa64c30ed987a4cd237ea21d2ef4207dd8 1724 mysql-dfsg-5.1_5.1.36-2.dsc
 d487fe596a2e4c9cacd407f77ad8c00fc9a75b53 327072 mysql-dfsg-5.1_5.1.36-2.diff.gz
 6461c500d8a5e63123111fbd48dad1b88bb20b4c 85306 libmysqlclient15-dev_5.1.36-2_all.deb
 af7034bf6a387c5f935dd0b939e2dd8c12832504 91640 mysql-common_5.1.36-2_all.deb
 f18db886592a29daa1ca7078677c04a91745c658 85484 mysql-server_5.1.36-2_all.deb
 0dd90d111fb1651147ae5fc0afe87c2a7bbce5d8 85362 mysql-client_5.1.36-2_all.deb
 14f73d9c21000d52669ee9da67387d4dcf06ee38 2023434 libmysqlclient16_5.1.36-2_amd64.deb
 4ab104c41cb7d52c2649a895c013d540d829efb7 4439414 libmysqld-pic_5.1.36-2_amd64.deb
 30975af8258023c8df8c71796a15515519e3566e 5547256 libmysqld-dev_5.1.36-2_amd64.deb
 433310b257174f2acf65912278e35bf4d67951b2 2384964 libmysqlclient-dev_5.1.36-2_amd64.deb
 ee6929b8321857c7e3462ef9178aa7b057d38264 8055696 mysql-client-5.1_5.1.36-2_amd64.deb
 5ab47b1655b4a3c96920b34008029ffd12222051 10765272 mysql-server-5.1_5.1.36-2_amd64.deb
Checksums-Sha256: 
 e5491aa0117fab135662511eef84f110f892476006cf0f6cf345539ee1eec037 1724 mysql-dfsg-5.1_5.1.36-2.dsc
 d11317d2960b85eb4b9ff096aeb2553a5b79b68a8bc1c9967301836ff1f8a627 327072 mysql-dfsg-5.1_5.1.36-2.diff.gz
 d3ad18e6ea6cae04012b29c9f6a6c23f619d29c0436d1ff0ed4b616b455225be 85306 libmysqlclient15-dev_5.1.36-2_all.deb
 4c6a29550dcd153f3f096b6a5a49c84178b999456aad77ce6c96bae8c1e8cd07 91640 mysql-common_5.1.36-2_all.deb
 f3f89399cd718e80738e50228ef9dd63d9c826c844625a3b4ce818eb6f82aa2b 85484 mysql-server_5.1.36-2_all.deb
 eda9d90a51b6fb6c7c1c944cf81e17c6aadde7e5cf9dcfa83cfc1cca50f02cf9 85362 mysql-client_5.1.36-2_all.deb
 c505dae6bef6988c34c42a53dc28f6fcf2f9ec0dddd85c8df3475e3c787e796a 2023434 libmysqlclient16_5.1.36-2_amd64.deb
 1e303a7a20e2d21149d3fb9442f92c0e25dac4e8772f320a9de705077e82bba8 4439414 libmysqld-pic_5.1.36-2_amd64.deb
 91dbe0d1858d0e95ccb230db62cf1e751b886d658a9c99b4e3007fffd84b0707 5547256 libmysqld-dev_5.1.36-2_amd64.deb
 84d9376d2a38aa859fce0c5067fb04a0185639ccc39c8cd1677699c5fd2afc46 2384964 libmysqlclient-dev_5.1.36-2_amd64.deb
 c37efd73450d91327d7fe6b14cbe8c0076b4cc51b35326fa9df8e43f18fcff0f 8055696 mysql-client-5.1_5.1.36-2_amd64.deb
 a4fc85100de982bf6246b296b8be5fc6a55580b69574608eea8f1023ef878fd0 10765272 mysql-server-5.1_5.1.36-2_amd64.deb
Files: 
 2dc227a147187e2464fbe51874097689 1724 misc optional mysql-dfsg-5.1_5.1.36-2.dsc
 14d79df7feae03fcec51bc8ae2e611e7 327072 misc optional mysql-dfsg-5.1_5.1.36-2.diff.gz
 61d898212217a29a8b3dc07ab4a93fa3 85306 libdevel optional libmysqlclient15-dev_5.1.36-2_all.deb
 0ece7a9a0a62ff4599eb3fdfa8463980 91640 database optional mysql-common_5.1.36-2_all.deb
 65569d20dda65c5c7cfa767288ea70b7 85484 database optional mysql-server_5.1.36-2_all.deb
 cc285d6b0d4c13901bd36bbf904bf375 85362 database optional mysql-client_5.1.36-2_all.deb
 16f647921ac63d80c8ef485e81918ed1 2023434 libs optional libmysqlclient16_5.1.36-2_amd64.deb
 4a6fbdc3a7480ada40f16f7cff7573a2 4439414 libdevel optional libmysqld-pic_5.1.36-2_amd64.deb
 7647acdd3ceceae43a8feb8a82046350 5547256 libdevel optional libmysqld-dev_5.1.36-2_amd64.deb
 51cdc1d5febb572ba57ee1644bc00909 2384964 libdevel optional libmysqlclient-dev_5.1.36-2_amd64.deb
 a412bcb26862f5d8825e358325ba2a0f 8055696 misc optional mysql-client-5.1_5.1.36-2_amd64.deb
 af639e79e7ff27cf9b479c9407804de3 10765272 misc optional mysql-server-5.1_5.1.36-2_amd64.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.9 (GNU/Linux)

iEYEARECAAYFAkpoukcACgkQkR9K5oahGOZfJQCgnMDbaFKheh7fzXETtceFgZt0
T80AmgOzhDj/ZGh5X9Tq8yCajK1s17po
=UrrI
-----END PGP SIGNATURE-----





Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Fri, 28 Aug 2009 07:28:43 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Thu Apr 24 22:48:21 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.